/*
================================================================================
Ce programme lit la valeur de tous les capteurs de la carte ESPLORA et les envoie
sur le terminale série du logiciel Arduino
 
 Laurent Coutelier
 Lycée Monge La chauvinière
 Nantes
 23/12/13
*/

// Importation des bibliothèques 
#include <Esplora.h> // Pour la carte ESPLORA

void setup()
{
  Serial.begin(9600);  // initialisation de la communication série ESPLORA-PC
                       // à 9600 Bds
} 

void loop()
{
  // Définition des variables et lecture des capteurs
  int xAxis = Esplora.readAccelerometer(X_AXIS);    // read the X axis
  int yAxis = Esplora.readAccelerometer(Y_AXIS);    // read the Y axis
  int zAxis = Esplora.readAccelerometer(Z_AXIS);    // read the Z axis
  int xValue = Esplora.readJoystickX();        // read the joystick's X position
  int yValue = Esplora.readJoystickY();        // read the joystick's Y position
  int button = Esplora.readJoystickSwitch();   // read the joystick pushbutton
  int Potlin = Esplora.readSlider();// lecture du potentiomètre linéaire
  int light = Esplora.readLightSensor(); //lecture du capteur de lumière
  int bp1 = Esplora.readButton(1);  // en bas
  int bp2 = Esplora.readButton(2); //à gauche
  int bp3 = Esplora.readButton(3);//en haut
  int bp4 = Esplora.readButton(4); //àdroite
  int Temp = Esplora.readTemperature(DEGREES_C);
  int loudness = Esplora.readMicrophone();
  
  //  affichage des valeurs lues
  Serial.print("x: ");      // print the label for X 
  Serial.print(xAxis);      // print the value for the acceleration X axis
  Serial.print("\ty: ");
  Serial.print(yAxis);      // print the value for the acceleration Y axis
  Serial.print("\tz: ");
  Serial.print(zAxis);    // print the value for the acceleration Z axis
  Serial.print("\tlight: "); 
  Serial.println(light);        // print the light sensor value
  Serial.print("Joystick X: ");
  Serial.print(xValue);         // print the joystick X value
  Serial.print("\tY: ");        
  Serial.print(yValue);         // print the joystick Y value
  Serial.print("\tButton: ");
  Serial.print(button);         // print the joystick button value
  Serial.print("\tPotlin: ");   
  Serial.println(Potlin);       // print the line sensor value
  Serial.print("\tBP1: "); 
  Serial.print(bp1);            // print the bp1 value (1 OFF, 0 ON)
  Serial.print("\tBP2: ");  
  Serial.print(bp2);            // print the bp2 value (1 OFF, 0 ON)
  Serial.print("\tBP3: ");     
  Serial.print(bp3);            // print the bp3 value (1 OFF, 0 ON)
  Serial.print("\tBP4: ");    
  Serial.println(bp4);          // print the bp4 value (1 OFF, 0 ON)
  Serial.print("\tson: ");                  
  Serial.print(loudness);       // print the loudness
  Serial.print("\ttemp: ");
  Serial.print(Temp);           // print the Temperature
  Serial.println("'C");          // in degree
  Serial.println();          // in degree

  delay(500);      // Pause syndicale obligatoire (Ce type d'écriture est à proscrire même si elle est 
                  // très pratique...).
}
