/*
================================================================================
Ce programme affiche sur l'écran TFT de la carte ESPLORA un texte au milieu en jaune et en taille 2.
Ce programme utilise la méthode String.toCharArray(char[], STRING.length()+1) pour convertir 
 du texte en tableau de caractères. +1 pour avoir le dernier caractère.
 Le tableau de caractères char[] doit être défini avec une taille de + 1 par rapport à la taille
 renvoyée par String.length() sinon, on court au dépassement de mémoire et au plantage du programme.
 
 Laurent Coutelier
 Lycée Monge La chauvinière
 Nantes
 23/12/13
*/

// Importation des bibliothèques 
#include <Esplora.h> // Pour la carte ESPLORA
#include <SPI.h>  // Pour le bus SPI
#include <TFT.h>  // Pour l'écran TFT

void setup(){
  Serial.begin(9600);
  EsploraTFT.begin();  // Pour démarrer l'écran TFT
  EsploraTFT.background(0,0,0);  // mise en place du fond noir
}

int i;

void loop(){
  String Mon_texte = "A Boire !";      // Définition de Mon_texte
  char text_tab[Mon_texte.length()+1]; // création du tableau de caractères +1 pour éviter le dépassement mémoire et le plantage
  Mon_texte.toCharArray(text_tab, Mon_texte.length()+1);  // conversion du texte en tableau de caractères
                                                          // le +1 est nécessaire pour avoir le dernier caractère.
                                                          // et pour éviter le plantage.                                                          
  EsploraTFT.stroke(255,255,0);// jaune pour le texte
  EsploraTFT.setTextSize(2); // taille caractère : 2 (2x(7*5) pixels)
  EsploraTFT.text(text_tab, 30, 50);// écriture sur l'écran TFT des caractères du tableau
  delay(300);
}





