/*
================================================================================
 Ce programme affiche sur l'écran  TFT de la carte ESPLORA, la température 
 mesurée sur la carte.
 Ce programme utilise la méthode String.toCharArray(char[], STRING.length()+1) 
 pour convertir  du texte en tableau de caractères. +1 pour avoir le dernier 
 caractère.
 Le tableau de caractères char[] doit être défini avec une taille de + 1 par 
 rapport à la taille renvoyée par String.length() sinon, on court au dépassement
 de mémoire et au plantage du programme.
 Cependant, idéalement, en partant d'un entier, au lieu de convertir en passant par un String, puis
 un tableau de caractères, il vaut mieux utiliser la méthode conversion directe : itoa(char[],int,DEC) d'un 
 entier en tableau de caractères. 
 L'effacement est réalisé par la réécruture du même texte en noir.

 
 Laurent Coutelier
 Lycée Monge La chauvinière
 Nantes
 23/12/13
 */

// Importation des bibliothèques 
#include <Esplora.h> // Pour la carte ESPLORA
#include <SPI.h>  // Pour le bus SPI
#include <TFT.h>  // Pour l'écran TFT

// Déclaration des variables communes 
  String temperature, anc_temperature; 
  char tempPrintout[3];  // tableau de caractères pour l'envoi sur l'acran TFT

void setup() {
  EsploraTFT.begin();
  EsploraTFT.background(0,0,0);  // mise en place du fond noir
  EsploraTFT.stroke(255,255,0);// Traits et texte en jaune
  EsploraTFT.setTextSize(2);  // taille de caractères 2
  //affiche les textes "fixes"
  EsploraTFT.text("Temperature",12,10); 
  EsploraTFT.stroke(30,30,255);  // met la couleur en bleu
  EsploraTFT.text("o",145,40);  // fait le rond de degré
  EsploraTFT.setTextSize(11);  // taille de caractères 5 pour l'affichage de la température
}

void loop() {
  //lecture enregistrement et conversion de la température
  temperature = String(Esplora.readTemperature(DEGREES_C));  // Lit la température et l'enregistre en chaîne

if(temperature!=anc_temperature){
  // Efface la température pour un réaffichage
  EsploraTFT.stroke(0,0,0); // Traits et texte en noir
  EsploraTFT.text(tempPrintout, 12, 40); // écrit la température (en noir)
  //affiche la température
  temperature.toCharArray(tempPrintout, 3);  // convertie la chaine en tableau de 3 caractères
  EsploraTFT.stroke(30,30,255);  // met la couleur en bleu
  EsploraTFT.text(tempPrintout, 12, 40);  // écrit la température (en bleu)
  anc_temperature=temperature;  // mise à jour de la variable ancienne
}
delay(1000);
}



