/*
================================================================================
 Ce programme affiche la valeur du tirage au sort d'un Dé à 20 faces sur l'écran 
 TFT de la carte ESPLORA. Le message Ready ! Press sw1 indique comment lancer le dé.
 Le message s'efface pour faire apparaitre la nouvelle valeur tirée au sort. Le message 
 réapparait au bout de 2 secondes avec la mise en gris clair de la dernière valeur. 
 Les coordonnées d'affichages sont modifiées en fonction du nombre de chiffres a 
 afficher.
 
 Laurent Coutelier
 Lycée Monge La chauvinière
 Nantes
 25/12/13
 */

// Importation des bibliothèques 
#include <Esplora.h> // Pour la carte ESPLORA
#include <SPI.h>  // Pour le bus SPI
#include <TFT.h>  // Pour l'écran TFT

void setup(){
  EsploraTFT.begin();  // Pour démarrer l'écran TFT
  EsploraTFT.background(0,0,0);  // mise en place du fond noir
    // Affiche Ready !"
  EsploraTFT.setTextSize(3);  // taille 3
  EsploraTFT.stroke(255,0,0);  // met la couleur en rouge
  EsploraTFT.text("Ready !", 20, 36);  // écrit les caractères de la valeur en rouge
  EsploraTFT.text("Press sw1", 3, 65);  // écrit les caractères de la valeur en rouge
}

// Déclaration des variables communes
int bouton, val_de, anc_val_de, pos_x, pos_y,anc_pos_x ,anc_pos_y ; 

void loop(){
  bouton= Esplora.readButton(1);  // lecture du bouton 1

    // lecture de l'appui sur le bouton 1 avec anti rebond
  while(bouton==1){    
    bouton= Esplora.readButton(1); 
  }
  while(bouton==0){    
    bouton= Esplora.readButton(1);  
  }
  val_de=random(1,20);  // tirage au sort de 1 à 20
  
  // Adaptation des coordonnées au nombre de chiffres a afficher
  if(val_de>9){
    // Positions pour 2 chiffres taille 14
  pos_x=2;
  pos_y=14;
   }
   else{
   // Positions pour 1 chiffre taille 14
  pos_x=50;
  pos_y=14;
   }
  affiche(anc_val_de, val_de);
 
}

// Fonction d'affichage pour les valeurs modifiées
void affiche(int anc_valeur, int intvaleur){
    // efface Ready !"
  EsploraTFT.setTextSize(3);
  EsploraTFT.stroke(0,0,0);  // met la couleur en rouge
  EsploraTFT.text("Ready !", 20, 36);  // écrit les caractères de la valeur en rouge
  EsploraTFT.text("Press sw1", 3, 65);  // écrit les caractères de la valeur en rouge

  EsploraTFT.setTextSize(14); 
  // Efface la précédente valeur par un rectangle colorié de la largeur occupée par les n caractères
  char anc_T[String(anc_valeur).length()+1];  // création d'un tableau de caractère. Le +1 sinon dépassement et plantage.
  itoa(anc_valeur,anc_T,DEC);  // conversion de l'entier en tableau de caractères
  EsploraTFT.stroke(0,0,0);  // met la couleur en blanc
  EsploraTFT.text(anc_T, anc_pos_x, anc_pos_y);  // écrit les caractères de la valeur en blanc

  //affiche la nouvelle valeur
  char T[String(intvaleur).length()+1];  // création d'un tableau de caractère. Le +1 sinon dépassement et plantage.
  itoa(intvaleur,T,DEC);  // conversion de l'entier en tableau de caractères
  EsploraTFT.stroke(255,255,255);  // met la couleur en blanc
  EsploraTFT.text(T, pos_x, pos_y);  // écrit les caractères de la valeur en blanc
  delay(2000);

  // Met la dernière valeur en gris clair
  EsploraTFT.stroke(150,150,150);  // met la couleur en gris
  EsploraTFT.text(T, pos_x, pos_y);  // réécrit la valeur du dé en gris
  // Affiche Ready !"
  EsploraTFT.setTextSize(3);
  EsploraTFT.stroke(255,0,0);  // met la couleur en rouge
  EsploraTFT.text("Ready !", 20, 36);  // écrit les caractères de la valeur en rouge
  EsploraTFT.text("Press sw1", 3, 65);  // écrit les caractères de la valeur en rouge
  anc_val_de= val_de;
  anc_pos_x =pos_x;
  anc_pos_y=pos_y;
}




