/*
================================================================================
 Ce programme affiche un rectangle de 10x30 au centre de l'écran TFT de la carte 
 ESPLORA. Le bord du rectangle en blanc et le coloriage en bleu.
 Le rectangle se déplace en fonction du mouvement du joystick. L'ancien rectangle
 est effacé puis le nouveau déplacé affiché. 
 
 Laurent Coutelier
 Lycée Monge La chauvinière
 Nantes
 25/12/13
 */

// Importation des bibliothèques 
#include <Esplora.h> // Pour la carte ESPLORA
#include <SPI.h>  // Pour le bus SPI
#include <TFT.h>  // Pour l'écran TFT

// constantes du programme
#define xwidth 10 // Largeur du rectangle
#define ywidth 20 // Hauteur du rectangle

int milieux, milieuy, joyposx, joyposy, anc_joyposx, anc_joyposy;

void setup(){
  //Serial.begin(9600);
  EsploraTFT.begin();  // Pour démarrer l'écran TFT
  EsploraTFT.background(0,0,0);  // mise en place du fond noir
  milieux=map(Esplora.readJoystickX(), 512, -512, 0, 159) ; 
  milieuy=map(Esplora.readJoystickY(), 512, -512, 127, 0) ; 
  EsploraTFT.stroke(255,255,255);  // traits et texte en blanc
  EsploraTFT.fill(0,0,255); // coloriage en bleu
}

void loop(){

  joyposx = map(Esplora.readJoystickX(), 512, -512, 0, 159) ; 
  joyposy = map(Esplora.readJoystickY(), 512, -512, 127, 0) ; 
  if(joyposx!=anc_joyposx | joyposy!=anc_joyposy ){
    //effacement du rectangle précédent
    EsploraTFT.stroke(0,0,0);  // traits et texte en noir
    EsploraTFT.fill(0,0,0); // coloriage en noir    
    EsploraTFT.rect(anc_joyposx-xwidth/2, anc_joyposy-ywidth/2, xwidth, ywidth);  // position du coin haut gauche du rectangle 
    // tracé du nouveau rectangle
    EsploraTFT.stroke(255,255,255);  // traits et texte en blanc
    EsploraTFT.fill(0,0,255); // coloriage en bleu    
    EsploraTFT.rect(joyposx-xwidth/2, joyposy-ywidth/2, xwidth, ywidth);  // position du coin haut gauche du rectangle 
  }

  // réactualisation des dernières valeurs    
  anc_joyposx=joyposx;
  anc_joyposy =joyposy;
}


