/*
================================================================================
 Ce programme affiche la courbe de la mesure du capteur de lumière.
 Chaque point est affiché toute les secondes. La valeur mesurée et la valeur
 moyenne sont affichées en texte.
 
 Laurent Coutelier
 Lycée Monge La chauvinière
 Nantes
 26/12/13
 */

// Importation des bibliothèques 
#include <Esplora.h> // Pour la carte ESPLORA
#include <SPI.h>  // Pour le bus SPI
#include <TFT.h>  // Pour l'écran TFT

int  i=0, Light, time, moy[160], moyenne, anc_moyenne, anc_Light ;
long somme;

void setup() {
  EsploraTFT.begin();
  axes(); // tracé des axes
}

void loop() {
    if((millis()/1000-time)>1){ // Une mesure par seconde
    time+=1;
    Light= Esplora.readLightSensor(); // lecture du capteur de lumière
    moy[i]=Light;  // enregistrement des valeurs pour calculer la moyenne
    for(int j=0;j<i;j++){
      somme=somme+moy[j];  // calcul de la somme totale
    }
    moyenne = somme/i; // Calcul de la moyenne
    somme=0;  // mise à zéro de la somme pour le calcul suivant.
    // Trace la courbe point par point
    EsploraTFT.stroke(255,255,255); // Traits et texte en Blanc
    EsploraTFT.point(i+10,map(Light, 0, 1023, 120, 0)); // affichage du point de la courbe
 // affichage de la valeur moyenne   
    if(moyenne!=anc_moyenne){
      // Efface l'ancienne valeur moyenne pour un réaffichage
      char anc_Tmoy[String(anc_moyenne).length()+1];  // tableau de caractères pour l'envoi sur l'acran TFT +1 indispensable
      itoa(anc_moyenne,anc_Tmoy,DEC);  // conversion de l'entier en tableau de caractères
      EsploraTFT.stroke(0,0,0);  //Couleur des traits et texte en noir
      EsploraTFT.text(anc_Tmoy, 44, 80);  // Ecriture de l'ancien texte en noir (effacement)

      //affiche la nouvelle valeur moyenne linéaire
      char Tmoy[String(moyenne).length()+1];  // tableau de caractères pour l'envoi sur l'acran TFT +1 indispensable
      itoa(moyenne,Tmoy,DEC);  // conversion de l'entier en tableau de caractères
      EsploraTFT.stroke(255,255,255);  // met la couleur en bleu
      EsploraTFT.text(Tmoy, 44, 80);  // ecrit la valeur du cuseur linéaire
      anc_moyenne=moyenne;  //mise à jour de la dernière valeur
    }
// affichage de la valeur en cours    
    if(Light!=anc_Light){
      // Efface l'ancienne valeur de Light pour un réaffichage
      char anc_TLight[String(anc_Light).length()+1];  // tableau de caractères pour l'envoi sur l'acran TFT +1 indispensable
      itoa(anc_Light,anc_TLight,DEC);  // conversion de l'entier en tableau de caractères
      EsploraTFT.stroke(0,0,0);  //Couleur des traits et texte en noir
      EsploraTFT.text(anc_TLight, 44, 70);  // Ecriture de l'ancien texte en noir (effacement)

      //affiche la nouvelle valeur du Light linéaire
      char TLight[String(Light).length()+1];  // tableau de caractères pour l'envoi sur l'acran TFT +1 indispensable
      itoa(Light,TLight,DEC);  // conversion de l'entier en tableau de caractères
      EsploraTFT.stroke(255,255,255);  // met la couleur en bleu
      EsploraTFT.text(TLight, 44, 70);  // ecrit la valeur du cuseur linéaire
      anc_Light=Light;  //mise à jour de la dernière valeur
    }

    i+=1;      // incrémentation des i
    if(i>159){ //   si dépassement fenêtre remise à zéro
      i=10;
      axes(); // affichage des axes
    }
  }
}  

// Fonction d'affichage des axes et textes fixes
void axes(){
  EsploraTFT.background(0,0,0);  // mise en place du fond noir
  EsploraTFT.stroke(255,255,0);// Traits et texte en jaune
  //affiche les textes "fixes"
  EsploraTFT.text("Courbe Light Sensor",20,100); 
  EsploraTFT.text("moy:",20,80);   // Affichage de la moyenne  
  EsploraTFT.text("val:",20,70);   // Affichage de la valeur mesurée
  EsploraTFT.stroke(255,255,255); // Traits et texte en blanc
  EsploraTFT.line(0, 120, 159, 120); // axe horizontal
  EsploraTFT.line(10, 127, 10, 0); // axe vertical
  EsploraTFT.line(150, 124, 159, 120); // flèche horizontal
  EsploraTFT.line(150, 116, 159, 120); // flèche horizontal
  EsploraTFT.line(6, 9, 10, 0); // flèche vertical  
  EsploraTFT.line(14, 9, 10, 0); // flèche vertical 

}







