/*
================================================================================
 Ce programme trace une étoile et la fait se déplacer aléatoirement sur l'écran
 La vitesse est réglée par le curseur qui change la distance entre deux positions 
 consécutives à période constante. 
 
 Laurent Coutelier
 Lycée Monge La chauvinière
 02/01/14
 */

// Importation des bibliothèques 
#include <Esplora.h> // Pour la carte ESPLORA
#include <SPI.h>  // Pour le bus SPI
#include <TFT.h>  // Pour l'écran TFT

//Définition des coordonnées des points d'une étoile, repère au centre de l'étoile
int coord[10]={
  0,-10,6,8,-9,-3,9,-3,-6,8};


int x1=0, x2=30, y1=0, y2=40; // cordonnées de départ et d'arrivée
int x, y, anc_x, anc_y; // coordonnée en cours pour traçage et précédente pour effaçage
float longueur, theta;  // calcul de la longueur de parcours et de son angle.
float  l; // longueur de positionnement sur le parcours



void setup(){
  Serial.begin(9600);
  EsploraTFT.begin();  // Pour démarrer l'écran TFT
  EsploraTFT.background(0,0,0);  // mise en place du fond noir
  //trace(159/2, 127/2); //pour tracer le motif (étoile)

  longueur=sqrt(float(pow((x2-x1),2)+pow((y2-y1),2))); // Calcul de la longueur du parcours (pythagore)
  if(y2-y1>0){  // détermination de l'angle théta et de son signe
    theta=acos(float(x2-x1)/longueur);
  }
  else
  {
    theta=-acos(float(x2-x1)/longueur);
  } 
}

void loop(){
  float depl= Esplora.readSlider(); //mesure de l'incrémentation de déplacement sur le curseur
    x=x1+l*cos(theta); //calcul de x et de y
    y=y1+l*sin(theta);
    l=l+depl/100;// incrémentation du déplacemenent en fonction de la position du curseur
    if(l>longueur){
    l=0.0; //remise à zéro de l
    y1=y2; // l'arrivée devient départ
    x1=x2;
// définition aléatoire de nouvelle coordonnées à atteindre 
  x2=random(10,149); 
  y2=random(10,117);
// recalcul de la longuer du parcours et de l'angle théta      
  longueur=sqrt(float(pow((x2-x1),2)+pow((y2-y1),2)));
  if(y2-y1>0){
    theta=acos(float(x2-x1)/longueur);
  }
  else
  {
    theta=-acos(float(x2-x1)/longueur);
  } 
    }
    efface(anc_x, anc_y);     // effacement de l'ancienne étoile
    trace(x,y);// et affichage de la nouvelle
    // mise à jour des anciennes coordonnées
    anc_x=x;  
    anc_y=y;
}


//Trace le motif aux cordonnées définies
void trace(int pos_x, int pos_y){
  EsploraTFT.stroke(255,255,255);  // traits et texte en blanc
  for(int i=0; i<7; i=i+2){
    EsploraTFT.line(coord[i]+pos_x, coord[i+1]+pos_y, coord[i+2]+pos_x, coord[i+3] +pos_y);     
  }
  EsploraTFT.line(coord[8]+pos_x, coord[9]+pos_y, coord[0]+pos_x, coord[1] +pos_y); 

  EsploraTFT.stroke(255,0,0);  // traits et texte en rouge
  EsploraTFT.fill(255,0,0);
  for(int i=0; i<10; i=i+2){
    EsploraTFT.circle(coord[i]+pos_x, coord[i+1]+pos_y, 1); 
delay(2); // Pour maintenir l'image un certain fixe
  }

}

//Efface le motif aux cordonnées définies
void efface(int pos_x, int pos_y){
  EsploraTFT.stroke(0,0,0);  // traits et texte en blanc
  for(int i=0; i<7; i=i+2){
    EsploraTFT.line(coord[i]+pos_x, coord[i+1]+pos_y, coord[i+2]+pos_x, coord[i+3] +pos_y);     
  }
  EsploraTFT.line(coord[8]+pos_x, coord[9]+pos_y, coord[0]+pos_x, coord[1] +pos_y); 

  EsploraTFT.stroke(0,0,0);  // traits et texte en rouge
  EsploraTFT.fill(0,0,0);
  for(int i=0; i<10; i=i+2){
    EsploraTFT.circle(coord[i]+pos_x, coord[i+1]+pos_y, 1); 

  }
}




