/*
================================================================================
 Ce programme déplace une balle et la fait rebondir sur les bords de l'écran. L'angle
 de rebond subie une influence aléatoire.
 La vitesse de la balle est gérée avec le curseur qui permet d'agir sur l'incrément 
 du déplacement. Le rafraichissement de la balle se fait à chaque nouvelle position 
 (chaque tour de la boucle loop)
 
 Laurent Coutelier
 Lycée Monge La chauvinière
 Nantes
 02/01/14
 */

// Importation des bibliothèques 
#include <Esplora.h> // Pour la carte ESPLORA
#include <SPI.h>  // Pour le bus SPI
#include <TFT.h>  // Pour l'écran TFT


int x1=159/2, y1=127/2; // cordonnées de départ
int x, y, anc_x, anc_y; // coordonnée en cours pour traçage et précédente pour effaçage
float longueur, theta;  // calcul de la longueur de parcours et de son angle.
float  l; // longueur de positionnement sur le parcours

void setup(){
  Serial.begin(9600);
  EsploraTFT.begin();  // Pour démarrer l'écran TFT
  EsploraTFT.background(0,0,0);  // mise en place du fond noir
  theta=random(0,200*PI)/100.0; 
}


void loop(){
  float depl= Esplora.readSlider(); //mesure du paramètre temps sur le curseur  
  //calcul des nouvelles coordonnées de x et de y
  x=x1+l*cos(theta);
  y=y1+l*sin(theta); 
  //rebondissement parois verticales   
  if(x>149 | x<10 | y>117 | y<10){
    if(x>149 | x<10 ){
      theta=PI-theta + random(1,10)/100.0;
      //Serial.print(theta);  Serial.print("  ");  Serial.print(l);Serial.print("  ");  Serial.print(x);Serial.print("  ");  Serial.println(y);
    }   
    //rebondissement parois horizontales     
    if( y>117 | y<10){
      theta=-theta + random(1,10)/100.0;
      //Serial.print(theta);  Serial.print("  ");  Serial.print(l);Serial.print("  ");  Serial.print(x);Serial.print("  ");  Serial.println(y);
    }
    /*  Le déplacement de la balle ne coince pas dans les angles dans la forme du programme actuelle.
     // cas des angles lors de blocage
     // en haut à droite
     if(x>149 & y<10 ){ theta=random(130,180)/40.0;}//défini un angle de sortie entre PI< théta <3PI/2
     // en bas à droite
     if(x>149 & y>117 ){theta=random(64,120)/40.0;}//défini un angle de sortie entre PI/2< théta <PI
     //en bas a gauche 
     if(x<10 & y>117 ){ theta=random(4,60)/40.0;}//défini un angle de sortie entre 0 < théta <PI/2
     // en haut à gauche
     if(x<10 & y<10 ){ theta=random(190,250)/40.0;}//défini un angle de sortie entre 3PI/2 < théta <2*PI
     */

    l=0.0; //remise à zéro de l
    // le départ à partir des coordonnées précédentes évite de se trouver dans des positions hors cadre
    x1=anc_x; 
    y1=anc_y;
    //Recalcul des nouvelles positions
    x=x1+l*cos(theta);
    y=y1+l*sin(theta); 
  }

  efface(anc_x, anc_y);     // effacement de l'ancien cercle
  trace(x,y);// et affichage de le nouveau cercle    
  l=l+depl/100; // incrémentation du déplacemenent en fonction de la position du curseur  
  // mise à jour des anciennes coordonnées
  anc_x=x;  
  anc_y=y; 
}


//Trace le motif aux cordonnées définies
void trace(int pos_x, int pos_y){
  EsploraTFT.stroke(255,0,0);  // traits et texte en rouge
  EsploraTFT.fill(255,0,0);
  EsploraTFT.circle(pos_x, pos_y, 10); 
  delay(20); // Pour maintenir l'image un certain fixe
}


//Efface le motif aux cordonnées définies
void efface(int pos_x, int pos_y){
  Serial.print(pos_x);  Serial.print(" ");  Serial.println(pos_y);
  EsploraTFT.stroke(0,0,0);  // traits et texte en rouge
  EsploraTFT.fill(0,0,0);
  EsploraTFT.circle(pos_x, pos_y, 10); 
}


