/*
================================================================================
 Ce programme déplace une balle et la fait rebondir sur les bords de l'écran. 
 Le mouvement de la balle est gérée avec l'accélération x et y (inclinaison de la
 carte ESPLORA). Le calcul du déplacement de la balle est fait à partir des équations
 cinématique du mouvement par itération de la position précédente vers la position 
 suivante.
 Le rafraichissement de la balle est fait à chaque nouvelle position différente de
 la précédente.
 
 Laurent Coutelier
 Lycée Monge La chauvinière
 Nantes
 02/01/14
 */

// Importation des bibliothèques 
#include <Esplora.h> // Pour la carte ESPLORA
#include <SPI.h>  // Pour le bus SPI
#include <TFT.h>  // Pour l'écran TFT
#define dt 0.01  // incrément de temps pour le calcul des vitesses et positions

int pos_x, pos_y, anc_pos_x, anc_pos_y ;// positions de traçage ancienne et nouvelle
float acc_x, acc_y, acc_x0, acc_y0, vit_x, vit_y , anc_vit_x, anc_vit_y , x, y, anc_x=159/2, anc_y=127/2; // paramètres cinématique anciens et nouveaux

void setup(){
  //Serial.begin(9600);
  EsploraTFT.begin();  // Pour démarrer l'écran TFT
  EsploraTFT.background(0,0,0);  // mise en place du fond noir
  trace(anc_pos_x,anc_pos_y);    // et affichage du cercle en position initiale 
 // Mesure de l'accélération zéro
  acc_x0=-Esplora.readAccelerometer(X_AXIS)/10; //le rapport de 10 joue sur la dynamique
  acc_y0=Esplora.readAccelerometer(Y_AXIS)/10;  //le rapport de 10 joue sur la dynamique
}


void loop(){
  // Mesure de l'accélération
  acc_x=-Esplora.readAccelerometer(X_AXIS)/10-acc_x0; //le rapport de 10 joue sur la dynamique
  acc_y=Esplora.readAccelerometer(Y_AXIS)/10-acc_y0; //le rapport de 10 joue sur la dynamique
    //calcul des nouvelles coordonnées de x et de y
  vit_x=anc_vit_x+acc_x*dt;
  vit_y=anc_vit_y+acc_y*dt;  
  x=anc_x + anc_vit_x*dt + acc_x*pow(dt,2)/2 ;
  y=anc_y + anc_vit_y*dt + acc_y*pow(dt,2)/2;  

    if( x>149 | x<10){
  //rebondissement parois verticales    
      vit_x=-vit_x;
      //Serial.print(theta);  Serial.print("  ");  Serial.print(l);Serial.print("  ");  Serial.print(x);Serial.print("  ");  Serial.println(y);
    }
 //rebondissement parois horizontales     
    if( y>117 | y<10){
    vit_y=-vit_y;
    }
pos_x = int(x);
pos_y = int(y);
if(anc_pos_x!=pos_x | anc_pos_y!=pos_y){
  efface(anc_pos_x, anc_pos_y);     // effacement de l'ancien cercle
  trace(pos_x, pos_y);// et affichage de le nouveau cercle   
   // mise à jour des anciennes valeurs de position tracées
   anc_pos_x=pos_x;
  anc_pos_y=pos_y;
}

 // mise à jour des anciennes valeurs de position et vitesse
  anc_x=x;  
  anc_y=y; 
  anc_vit_x=vit_x;
  anc_vit_y=vit_y;
}

//Trace le motif aux cordonnées définies
void trace(int pos_x, int pos_y){
  EsploraTFT.stroke(255,0,0);  // traits et texte en rouge
  EsploraTFT.fill(255,0,0);
  EsploraTFT.circle(pos_x, pos_y, 10); 
  //delay(40); // Pour maintenir l'image un certain fixe , ralenti le mouvement aussi
}


//Efface le motif aux cordonnées définies
void efface(int pos_x, int pos_y){
  Serial.print(pos_x);  Serial.print(" ");  Serial.println(pos_y);
  EsploraTFT.stroke(0,0,0);  // traits et texte en rouge
  EsploraTFT.fill(0,0,0);
  EsploraTFT.circle(pos_x, pos_y, 10); 
}


