/*
================================================================================
 Ce programme montre comment initialiser le lecteur SD, créer, effacer et 
 tester la présence d'un fichier
 
 Laurent Coutelier
 Lycée Monge La chauvinière
 25/12/13
 */

#include <Esplora.h>	// bibli carte ESPLORA
#include <SPI.h>	// bibli bus SPI
#include <SD.h>	// bibli carte SD
#include <TFT.h>            // Arduino LCD library

File myFile;

void setup()
{
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  EsploraTFT.begin();
  EsploraTFT.background(0, 0, 0);
  EsploraTFT.stroke(0, 255, 255);
  EsploraTFT.stroke(0, 255, 255);
  EsploraTFT.text("ouverture d'un fichier", 0, 0); 
  EsploraTFT.stroke(255, 255, 255);
  EsploraTFT.text("ouvrir le terminal serie", 0, 8); 
  EsploraTFT.text("pour demarrer", 0, 16); 

  while (!Serial) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }
  EsploraTFT.background(0, 0, 0);
  Serial.print("Initializing SD card...");  
  EsploraTFT.text("Initializing SD card...", 0, 8); 
  if (!SD.begin(8)) {
    Serial.println("initialization failed!");
      EsploraTFT.text("initialization failed!", 0, 16); 
    return;
  }
  Serial.println("initialization done.");
  EsploraTFT.text("initialization done.", 0, 16); 

  if (SD.exists("example.txt")) {
    Serial.println("example.txt exists.");
    EsploraTFT.text("example.txt existe.", 0, 24); 
  }
  else {
    Serial.println("example.txt doesn't exist.");
        EsploraTFT.text("example.txt n'existe pas.", 0, 24); 
  }

  // open a new file and immediately close it:
  Serial.println("Creating example.txt...");
  EsploraTFT.text("Creating example.txt...", 0, 32); 
  myFile = SD.open("example.txt", FILE_WRITE);
  myFile.close();


  if (SD.exists("example.txt")) {
    Serial.println("example.txt exists.");
    EsploraTFT.text("example.txt existe.", 0, 40); 
  }
  else {
    Serial.println("example.txt doesn't exist.");
        EsploraTFT.text("example.txt n'existe pas.", 0,40); 
  }

 // delete the file:
  Serial.println("Removing example.txt...");
 EsploraTFT.text("Removing example.txt...", 0,48); 
  SD.remove("example.txt");

  if (SD.exists("example.txt")) {
    Serial.println("example.txt exists.");
    EsploraTFT.text("example.txt existe.", 0, 56); 
  }
  else {
    Serial.println("example.txt doesn't exist.");
        EsploraTFT.text("example.txt n'existe pas.", 0,56); 
  }
}


void loop()
{
  // nothing happens after setup finishes.
}

