/*
================================================================================
 Ce programme montre comment écrire, lire dans un fichier sur une carte SD 
 tester la présence d'un fichier
 
 Laurent Coutelier
 Lycée Monge La chauvinière
 25/12/13
 */

#include <Esplora.h>	// bibli carte ESPLORA
#include <SPI.h>	// bibli bus SPI
#include <SD.h>	// bibli carte SD
#include <TFT.h>            // Arduino LCD library

File myFile;

void setup()
{
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  EsploraTFT.begin();
  EsploraTFT.background(0, 0, 0);
  EsploraTFT.stroke(0, 255, 255);
  EsploraTFT.stroke(0, 255, 255);
  EsploraTFT.text("ouverture d'un fichier", 0, 0); 
  EsploraTFT.stroke(255, 255, 255);
  EsploraTFT.text("ouvrir le terminal serie", 0, 8); 
  EsploraTFT.text("pour demarrer", 0, 16); 

  while (!Serial) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }
  EsploraTFT.background(0, 0, 0);
  Serial.print("Initializing SD card...");  
  EsploraTFT.text("Initializing SD card...", 0, 8); 
  if (!SD.begin(8)) {
    Serial.println("initialization failed!");
    EsploraTFT.text("initialization failed!", 0, 16); 
    return;
  }
  Serial.println("initialization done.");
  EsploraTFT.text("initialization done.", 0, 16); 

  if (!SD.exists("exemple.txt")) {
    // open a new file and immediately close it:
    Serial.println("Creating exemple.txt...");
    EsploraTFT.text("Creating exemple.txt...", 0, 24); 
    myFile = SD.open("exemple.txt", FILE_WRITE);
    myFile.close();
  }

  if (SD.exists("exemple.txt")) {
    Serial.println("exemple.txt existe.");
    EsploraTFT.text("exemple.txt existe.", 0, 32);  

    myFile = SD.open("exemple.txt", FILE_WRITE); // ouvre le fichier en écriture
    myFile.println("testing 1, 2, 3.");  // écrit du texte dans le fichier 
    myFile.println(123456);  // écrit une valeur dans le fichier    
    float a=12.354;
    myFile.println(a);  // écrit une valeur float dans le fichier      
    //myFile.close();
    
    myFile.seek(0) ;// retour au début du fichier
    //myFile = SD.open("exemple.txt",FILE_READ );
    // read from the file until there's nothing else in it:
    String fichier;
    while (myFile.available()) {
      Serial.write(myFile.read()); //Envoi et affiche les caractères via leur code Ascii
    }      // avec print au lieu de write, ce sont les codes ascii qui sont affichés
    //myFile.close(); 
    myFile.seek(0) ;// retour au début du fichier
    //myFile = SD.open("exemple.txt",FILE_READ );
    while (myFile.available()) {
      fichier=fichier+ myFile.read()+" "; //Les codes ascii s'empilent séparés par un espace
      //Serial.write(myFile.read());
    }
    myFile.close(); 
    Serial.println(fichier); // affiche la liste des codes ascii transmis.
  }  
  else {
    Serial.println("exemple.txt doesn't exist.");
    EsploraTFT.text("exemple.txt n'existe pas.", 0,32); 
  }
  SD.remove("exemple.txt");
}


void loop()
{
  // nothing happens after setup finishes.
}






