/*
================================================================================
 Ce programme affiche sur l'écran TFT de la carte ESPLORA, la valeur du curseur linéaire 
 Ce programme utilise la méthode String.toCharArray(char[], STRING.length()+1) pour convertir 
 du texte en tableau de caractères. +1 pour avoir le dernier caractère.
 Le tableau de caractères char[] doit être défini avec une taille de + 1 par rapport à la taille
 renvoyée par String.length() sinon, on court au dépassement de mémoire et au plantage du programme.
 Cependant, idéalement, en partant d'un entier, au lieu de convertir en passant par un String, puis
 un tableau de caractères, il vaut mieux utiliser la méthode conversion directe : itoa(char[],int,DEC) d'un 
 entier en tableau de caractères. 
 L'effacement est réalisé par la réécruture du même texte en noir.
   
 Laurent Coutelier
 Lycée Monge La chauvinière
 Nantes
 23/12/13
 */

// liaison des librairies au programme
#include <Esplora.h>  
#include <TFT.h>            // Arduino LCD library
#include <SPI.h>

// Déclaration des variables communes  
  String curseur, anc_curseur; 

void setup() {
  EsploraTFT.begin();
  EsploraTFT.background(0,0,0);
}

void loop() {

  //lecture enregistrement et conversion du curseur linéaire
  curseur =  String(Esplora.readSlider());// lecture du potentiomètre linéaire

if(curseur!=anc_curseur){
  // Efface la valeur du curseur ancienne pour un réaffichage en noir
  char anc_T[anc_curseur.length()+1];    // création du tableau de caractères pour l'envoi sur l'acran TFT, +1
                                         // pour éviter le dépassement mémoire et le plantage
  anc_curseur.toCharArray(anc_T, anc_curseur.length()+1);  // convertie la chaine en tableau de 3 caractères
  EsploraTFT.stroke(0,0,0);  // Couleur des traits et texte en noir
  EsploraTFT.text(anc_T, 12, 40);  // Ecriture de l'ancien texte en noir (effacement)
/*  // Ci-dessous, effacement par rectangle noir
  EsploraTFT.stroke(0,0,0);
  EsploraTFT.fill(0,0,0);
  EsploraTFT.rect(12, 40, 6*4, 8); 
  EsploraTFT.noFill(); 
*/
  //affiche la nouvelle valeur du cuseur linéaire
  char T[curseur.length()+1];  // tableau de caractères pour l'envoi sur l'acran TFT
  curseur.toCharArray(T, curseur.length()+1);  // convertie la chaine en tableau de 3 caractères
  EsploraTFT.stroke(255,255,255);  // met la couleur en blanc
  EsploraTFT.text(T, 12, 40);  // ecrit la valeur du cuseur linéaire

   anc_curseur=curseur;  //mise à jour de la dernière valeur
}
delay(100);
}

