/*
================================================================================
 Ce programme affiche sur l'écran TFT de la carte ESPLORA, la valeur du curseur 
 linéaire. 
 Ce programme utilise la fonction itoa() pour convertir directement un entier en
 tableau de caractère.
 La taille du tableau de caractères char[] est définie en passant par un transtypage
 passager de l'entier avec String(Mon_entier).length(). 

 L'effacement est réalisé par la réécruture du même texte en noir. On peut utiliser
 aussi un rectangle noir.
   
 Laurent Coutelier
 Lycée Monge La chauvinière
 Nantes
 23/12/13
 */

// liaison des librairies au programme
#include <Esplora.h>  
#include <TFT.h>            // Arduino LCD library
#include <SPI.h>

// Déclaration des variables communes  
  int curseur, anc_curseur; 

void setup() {
  EsploraTFT.begin();
  EsploraTFT.background(0,0,0);
    char T[String(curseur).length()+1];  // tableau de caractères pour l'envoi sur l'acran TFT
  itoa(curseur, T, DEC)  ;                                     

}

void loop() {

  //lecture enregistrement et conversion du curseur linéaire
  curseur = Esplora.readSlider();// lecture du potentiomètre linéaire

if(curseur!=anc_curseur){
  // Efface la valeur du curseur ancienne pour un réaffichage en noir
  char anc_T[String(anc_curseur).length()];    // création du tableau de caractères pour l'envoi sur l'acran TFT, 
                                         // pour éviter le dépassement mémoire et le plantage
  itoa(anc_curseur, anc_T, DEC)  ;                                     
  EsploraTFT.stroke(0,0,0);  // Couleur des traits et texte en noir
  EsploraTFT.text(anc_T, 12, 40);  // Ecriture de l'ancien texte en noir (effacement)
/*  // Ci-dessous, effacement par rectangle noir
  EsploraTFT.stroke(0,0,0);
  EsploraTFT.fill(0,0,0);
  EsploraTFT.rect(12, 40, 6*4, 8); 
  EsploraTFT.noFill(); 
*/
  //affiche la nouvelle valeur du cuseur linéaire
  char T[String(curseur).length()];  // tableau de caractères pour l'envoi sur l'acran TFT
  itoa(curseur, T, DEC)  ;                                     
  EsploraTFT.stroke(255,255,255);  // met la couleur en blanc
  EsploraTFT.text(T, 12, 40);  // ecrit la valeur du cuseur linéaire

  anc_curseur=curseur;  //mise à jour de la dernière valeur
}
delay(50);
}

