/*
================================================================================
 Ce programme compte les secondes qui sécoule à partir de la fonction millis().

 L'effacement est réalisé par la réécruture du même texte en noir. On peut utiliser
 aussi un rectangle noir.
   
 Laurent Coutelier
 Lycée Monge La chauvinière
 Nantes
 2/01/14
 */

// Importation des bibliothèques 
#include <Esplora.h> // Pour la carte ESPLORA
#include <SPI.h>  // Pour le bus SPI
#include <TFT.h>  // Pour l'écran TFT

long time, seconde ;

void setup(){
  EsploraTFT.begin();            // démarrage de l'écran TFT
  EsploraTFT.background(0,0,0);  // mise en place du fond noir
}

void loop(){
  if (time+1000<millis())// Si dépassement, 1 seconde s'est écoulé, 1000 ms = 1 s  !!
  {
    seconde +=1;     // une seconde de plus !!
    time=time+1000;  // incrémentation de time

    // Ci-dessous, effacement par rectangle noir
    EsploraTFT.stroke(0,0,0);
    EsploraTFT.fill(0,0,0);
    EsploraTFT.rect(12, 40, 6*4, 8); 
    EsploraTFT.noFill(); 

    //affiche la nouvelle valeur de seconde
    char T[String(seconde).length()];// tableau de caractères pour l'envoi sur l'acran TFT
    itoa(seconde, T, DEC)  ;         // conversion de l'entier en tableau de caractères                          
    EsploraTFT.stroke(255,255,255);  // met la couleur en blanc
    EsploraTFT.text(T, 12, 40);      // ecrit sur l'écran TFT le contenu du tableau de caractères 
  }
}

