/*
Ce programme écrit pour la carte Esplora d'Arduino permet de sortir un nombre aléatoire.
L'initialisation de la fonction random via la fonction randomSeed() est fait  
avec une mesure de la valeur numérique sur l'entreé analogique "à l'air libre"
TinkerKit IN-A ici. La valeur est lue via le paramétrage du multiplexeur (valeur 8)
et la lecture de la valeur analogique A4 à laquelle est relié le multiplexeur.
Voir la fonction void init_random() pour plus de détail.

Le nombre aléatoire est obtenu avec la fonction random() dans le void loop() et le
résultat est visible sur le terminale série.

Laurent Coutelier
Lycée Monge La Chauvinière
Nantes
Le 19/02/14
*/

#include <Esplora.h>  // Inutile dans ce programme peut être supprimé 
#include <SPI.h>      // Inutile dans ce programme peut être supprimé 
#include <TFT.h>      // Inutile dans ce programme peut être supprimé 
#include <SD.h>       // Inutile dans ce programme peut être supprimé 

long randNumber;

/*--------------------------------------------------------------------------------*/
void setup(){
EsploraTFT.begin();  // Inutile dans ce programme peut être supprimé 
SD.begin(8);         // Inutile dans ce programme peut être supprimé 
Serial.begin(9600);  // Pour affichage vers Terminal série
delay(5000);         // pause de 5 s pour voir démarrer le random
init_random();
}


/*--------------------------------------------------------------------------------*/
void init_random(){
  //paramétrage du multiplexeur pour lire sur l'entrée Tinkerkit IN-A ou IN-B
byte channel = 8 ; // 8 pour tinkerkit in-A,  9 pour tinkerkit IN-B
pinMode(A0, OUTPUT);  
pinMode(A1, OUTPUT); 
pinMode(A2, OUTPUT);  
pinMode(A3, OUTPUT); 
digitalWrite(A0, (channel & 1) ? HIGH : LOW);
digitalWrite(A1, (channel & 2) ? HIGH : LOW);
digitalWrite(A2, (channel & 4) ? HIGH : LOW);
digitalWrite(A3, (channel & 8) ? HIGH : LOW); 
Serial.print("lecture analogique : ");
Serial.println(analogRead(A4));  // visualisation de la valeur aléatoire 
randomSeed(analogRead(A4));    // application de l'initialisation aléatoire

// RAZ multiplexeur
channel = 0 ; // 8 pour tinkerkit in-A,  9 pour tinkerkit IN-B
digitalWrite(A0, (channel & 1) ? HIGH : LOW);
digitalWrite(A1, (channel & 2) ? HIGH : LOW);
digitalWrite(A2, (channel & 4) ? HIGH : LOW);
digitalWrite(A3, (channel & 8) ? HIGH : LOW); 
}


/*--------------------------------------------------------------------------------*/
void loop(){
randNumber = random(10, 20);  //sortie aléatoire d'un compris entre 10 et 20 
Serial.println(randNumber);  // Envoi sur le terminal série
delay(300);                  // pause de 0,3 s
}


