/*
//--------------------------------------------------------------------------------//
Ce fichier écrit des nombres de différents type (int, unsigned int, unsigned long )
dans un fichier sur la carte SD, puis relit les octets.


Laurent Coutelier
Lycée Monge La Chauvinière
Nantes
Le 05/03/14
*/



#include <Esplora.h>
//#include <SPI.h>
#include <SD.h>

// Variable communes
File mon_fichier;
char tab_char[5];
char tab_char_lu[5];
int entier1, entier2;  
unsigned int entier_ns2;
unsigned long nombre_long; 



//--------------------------------------------------------------------------------//
void echange(int entree){
Serial.print("echange entier=");
  for (int i=0;i<2;i++){
tab_char[i] = entree & 255;
Serial.print((byte) tab_char[i]);
Serial.print(" ");
entree=entree>>8;
}
Serial.println();
}

//--------------------------------------------------------------------------------//
void echange2(unsigned long entree){
  Serial.print("echange entier long=");
for (int i=0;i<4;i++){
tab_char[i] = entree & 255;
Serial.print((byte)tab_char[i]);
Serial.print(" ");
entree=entree>>8;
}
Serial.println();
}


//--------------------------------------------------------------------------------//
// enregistrement de données type entier
void ecrit_entier(){
  mon_fichier = SD.open("fichier.abc", FILE_WRITE);
  for (int i=0;i<2;i++){
  mon_fichier.write(tab_char[i]);}
  mon_fichier.close();
  Serial.println("Ecriture entier finie"); 
}

//--------------------------------------------------------------------------------//
// enregistrement de données type entier long
void ecrit_entier_long(){
  mon_fichier = SD.open("fichier.abc", FILE_WRITE);
  for (int i=0;i<4;i++){
  mon_fichier.write(tab_char[i]);}
  mon_fichier.close();
  Serial.println("Ecriture entier long finie"); 
}


//--------------------------------------------------------------------------------//
void setup ()
{
  delay(5000); // laisse un moment pour démarrer le terminal série
  Serial.begin(9600); // paramétrage du terminal série
     while (!Serial) {
    ; // attend que le terminal série soit ouvert
  }
  //SD.begin(8);  // démarrage du lecteur SD sans test de vérification de démarrage
  if (!SD.begin(8)) { //démarrage du lecteur SD avec test de vérification de démarrage
    Serial.println("carte SD absente ! initialisation en echec.");
    //return;
}else{Serial.println("1Carte SD presente,  initialisation reussie !");}

// Effacement du fichier précédent
  if(SD.exists("fichier.abc"))SD.remove("fichier.abc");

  // création d'un fichier puis fermeture
  Serial.println("Creation de fichier.abc...");
  mon_fichier = SD.open("fichier.abc", FILE_WRITE);
  mon_fichier.close();
 // test de l'existence du fichier
  if(SD.exists("fichier.abc")){
    Serial.println("Le fichier fichier.abc existe");
  }
  else  {
    Serial.println("Le fichier fichier.abc n'existe pas");
  }
  

// Affection des valeurs
 entier1=20000;  // (=20000 ! = 0x4E20 (78 et 32) = 0b100111000100000)
 entier2=-20000;  // (0xB1E0    177 224    équivalent 45536)
 entier_ns2=40000; // (0x9C40        156  64)
 nombre_long=2147483647; //  (0x7FFFFFFF    127 255 255 255)
 
 //Affichage des valeurs enegistrées
    Serial.println();
 Serial.println("Affichage des valeurs enegistrees");
 Serial.print("entier1="); 
  Serial.println(entier1);
  Serial.print("entier2=");
  Serial.println(entier2);
  Serial.print("entier_ns2=");
   Serial.println(entier_ns2);
   Serial.print("nombre_long=");
   Serial.println(nombre_long);
   Serial.println();
  
  
  
 // Décomposition des octets, affichage et écriture
 echange(entier1);
 ecrit_entier();
 echange(entier2);
 ecrit_entier();
 echange(entier_ns2);
 ecrit_entier();  
echange2(nombre_long);
 ecrit_entier_long();

// Lecture des octets du fichier
  mon_fichier = SD.open("fichier.abc", FILE_READ);
Serial.println("octets lus");
  while(mon_fichier.available()){
Serial.println(mon_fichier.read());  // Lit l'octet et l'affiche en format décimal
  }
 mon_fichier.close();
  Serial.println("Lecture finie"); 
  
  
  // Recalcul des valeurs stockées dans le fichier
  mon_fichier = SD.open("fichier.abc", FILE_READ);  
Serial.println(lecture_entier_s());
Serial.println(lecture_entier_s());
Serial.println(lecture_entier_ns());
lecture_entier_long();
  mon_fichier.close();
  Serial.println("Recalcul fini"); 
}

//--------------------------------------------------------------------------------//
int lecture_entier_s(){
  int entier_lu;
for (int i=0;i<2;i++){
entier_lu=entier_lu+mon_fichier.read()*pow(256,i);
}
return entier_lu;
}

//--------------------------------------------------------------------------------//
unsigned int lecture_entier_ns(){
  unsigned int entier_lu;
for (int i=0;i<2;i++){
entier_lu=entier_lu+mon_fichier.read()*pow(256,i);
}
return entier_lu;
}

//--------------------------------------------------------------------------------//
void lecture_entier_long(){
  unsigned long entier_lu;
  byte octet_lu;
// Le calcul est répété 4 fois car la boucle for avec la fonction pow()
// donne des ecarts

  octet_lu=mon_fichier.read();
entier_lu=entier_lu+octet_lu*((unsigned long)pow(256,0));
   //Serial.print("octet_lu=");
   //Serial.print(octet_lu);Serial.print(" ");
   //Serial.print("entier_lu=");
   //Serial.println(entier_lu);
  octet_lu=mon_fichier.read();
entier_lu=entier_lu+octet_lu*((unsigned long)pow(256,1));

   //Serial.print("octet_lu=");
   //Serial.print(octet_lu);Serial.print(" ");
   //Serial.print("entier_lu=");
   //Serial.println(entier_lu);


  octet_lu=mon_fichier.read();
entier_lu=entier_lu+octet_lu*((unsigned long)pow(256,2));

   //Serial.print("octet_lu=");
   //Serial.print(octet_lu);Serial.print(" ");
   //Serial.print("entier_lu=");
   //Serial.println(entier_lu);

  octet_lu=mon_fichier.read();
//Serial.print("octet_lu=");
//Serial.print(octet_lu);Serial.println(" ");
//Serial.println((unsigned long)pow(256,3));
//Serial.println(octet_lu*((unsigned long)pow(256,3)));
//Serial.println(entier_lu+octet_lu*((unsigned long)pow(256,3)));
entier_lu=entier_lu+octet_lu*((unsigned long)pow(256,3));

   Serial.print("entier_lu=");
   Serial.println(entier_lu);
}



//--------------------------------------------------------------------------------//
void loop () {
}









